 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   Automatic escaping of non-printable characters
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


First checking that printf with octal ascii codes does what we expect:

  $ printf "%s\n" "  $ printf '\101\077\n'" > printf.t
  $ cat printf.t
    $ printf '\101\077\n'
  $ kuulto-run1 printf.t
   ________________________________________________________________________
  /                                                                printf.t
    $ printf '\101\077\n'
    A?
  \________________________________________________________________________


Non-printable characters:

  $ printf "%s\n" "  $ printf '\001\002\003\n'" > np1.t
  $ kuulto-run1 np1.t
   ________________________________________________________________________
  /                                                                   np1.t
    $ printf '\001\002\003\n'
    \x01\x02\x03 (esc)
  \________________________________________________________________________


Mix of printable and non-printable:

  $ cat <<EOF > np2.t
  > Test non printable:
  >   $ printf '\116 \016 \117 \017 \120\n'
  >   $ printf '\020 \121 \021 \122\n'
  >   $ printf '\022 \123 \023\n'
  >   $ printf '\124 \024\n'
  > End
  > EOF
  $ kuulto-run1 np2.t
   ________________________________________________________________________
  /                                                                   np2.t
  Test non printable:
    $ printf '\116 \016 \117 \017 \120\n'
    N \x0e O \x0f P (esc)
    $ printf '\020 \121 \021 \122\n'
    \x10 Q \x11 R (esc)
    $ printf '\022 \123 \023\n'
    \x12 S \x13 (esc)
    $ printf '\124 \024\n'
    T \x14 (esc)
  End
  \________________________________________________________________________


Carriage return:

  $ printf "%s\n" "  $ printf 'CR: \r\n'" > cr.t
  $ kuulto-run1 cr.t
   ________________________________________________________________________
  /                                                                    cr.t
    $ printf 'CR: \r\n'
    CR: \r (esc)
  \________________________________________________________________________


Tab character:

  $ printf '\t\thop\n\ttab\n\t\t\tstop\n'
  		hop
  	tab
  			stop
  $ printf "%s\n" "  $ printf '\t\thop\n\ttab\n\t\t\tstop\n'" > tab.t
  $ kuulto-run1 tab.t
   ________________________________________________________________________
  /                                                                   tab.t
    $ printf '\t\thop\n\ttab\n\t\t\tstop\n'
    \t\thop (esc)
    \ttab (esc)
    \t\t\tstop (esc)
  \________________________________________________________________________


The end.
