 ~~~~~~~~~~~~~~~~~~~~~~~~~~
   Shell file descriptors
 ~~~~~~~~~~~~~~~~~~~~~~~~~~

Verifying that no file descriptor is leaked into the executing shell.
To that end close-on-exec ought to be set whenever possible.


This test relies on a Linux kernel with /proc mounted. Skipping it if
those conditions are not met:

  $ uname -s | grep -i -q linux || exit 80
  $ if [ ! -d /proc/self/ ]; then exit 80; fi


Check that a shell spawn by kuulto-run1 only has its standard file
descriptors open:

  $ cat <<EOF > check_fd_leak.t
  >   $ ls -1 /proc/\$$/fd/
  > EOF
  $ kuulto-run1 check_fd_leak.t
   ________________________________________________________________________
  /                                                         check_fd_leak.t
    $ ls -1 /proc/$$/fd/
    0
    1
    2
  \________________________________________________________________________


The end.
